'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _pipe = require('./pipe');

var _pipe2 = _interopRequireDefault(_pipe);

var _types = require('./types');

var _arr = require('./arr');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var getKeys = function getKeys(obj) {
  return Object.keys(obj);
};
var findKey = function findKey(lookupObj) {
  return function (arr) {
    return arr.find(function (key) {
      return !!lookupObj[key];
    });
  };
};
var getValue = function getValue(lookupObj) {
  return function (key) {
    return lookupObj[key];
  };
};

var Parser = function () {
  function Parser(routes) {
    _classCallCheck(this, Parser);

    this.routes = routes;
  }

  _createClass(Parser, [{
    key: 'getRoutes',
    value: function getRoutes() {
      return this.routes;
    }
  }, {
    key: 'parse',
    value: function parse() {
      var payload = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      try {
        if (!(0, _types.isObject)(payload)) {
          return null;
        }

        var routes = this.getRoutes();

        // Find the key that is used to config the route
        var routeConfig = (0, _pipe2.default)(getKeys, _arr.lowercase, findKey(routes), getValue(routes))(payload);

        // Generate navigation action
        var routeName = routeConfig.routeName,
            params = routeConfig.params;


        var navigationAction = {
          routeName: (0, _types.isFunc)(routeName) ? routeName(payload) : routeName
        };

        if (params) {
          navigationAction.params = (0, _types.isFunc)(params) ? params(payload) : params;
        }

        if (__DEV__) {
          console.log('(DeeplinkParser) navigationAction:', navigationAction);
        }

        return navigationAction;
      } catch (err) {
        return null;
      }
    }
  }]);

  return Parser;
}();

exports.default = Parser;